/*
    This file is part of O3.
    Copyright 2002, 2003 Stu Mark
    This program is distributed under the terms of the GNU 
    General Public License 

    O3 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    O3 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with O3; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef FILELIST_H
#define FILELIST_H

#include <dirent.h>
#include <Q/memm.h>

/* Instructions:

   filelist(char *directory, char *extention, char *prefix); 
     This will create an object which is a list of files in the specified directory
     with the specified extention and/or prefix.
     If they are both null, it will take everything. 

   int numitems(void) // returns the number of files in the list.
   Memory &operator[](int num) // returns item number num from the list.

   Example:
   
   filelist fl("/tmp", ".txt.", NULL);
   int lp;
   for (lp = 0; lp < fl.numitems(); lp++)
     cout << fl[lp] << endl;
          
*/


int sel(const struct dirent *checkit); // they made me do it

class filelist
  {
    public:
      enum {SORTNONE, SORTNAME};

      filelist (char *directory, char *extention, char *prefix, int sorttype = filelist::SORTNONE);
      ~filelist(void);
      int numitems(void) { return count; }
      Memory &operator[](int num);
      static char *getext(void) { return ext; }
      static char *getprefix(void) { return prefix; }
    
    private:
      struct dirent **files;
      int count;
      Memory turner;
      static Memory ext; // they made me do this also.
      static Memory prefix; // and this too.
  };


#endif

