/*
    This file is part of O3.
    Copyright 2002, 2003 Stu Mark
    This program is distributed under the terms of the GNU 
    General Public License 

    O3 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    O3 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with O3; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "zary.h"

int zary::Add (entry *item)
  {
    // we take ownership of this item
    
    // first look for an empty spot
    int lp;
    int spot = -1;
    int fillin = FALSE; 
    for (lp = 0; lp < itemscount; lp++)
      if (used[lp] == FALSE)
        {
          spot = lp;
          fillin = TRUE;
          break;
        }
    if (spot == -1)
      if (itemscount >= memitemscount)
        {
          const int memjump = 5; // make room for 5 at a time
          /* Make more room in the list */
          entry **temp;
          temp = (entry **)getmem(sizeof(item) * (memitemscount + memjump));
          memcpy (temp, items, sizeof(item) * (itemscount+1));
          freemem((char *)items);
          items = temp;

          /* now move the used list. I think this was the problem. :-) */
          ZFLAG *temp2;
          int size = sizeof(ZFLAG);
          temp2 = (ZFLAG *)getmem(size * (memitemscount + memjump));
          memcpy (temp2, used, size * (itemscount+1)); // move the flags
          freemem((char *)used);
          used = temp2;

          memitemscount += memjump;
          spot = itemscount;
        }
      else
        spot = itemscount; // go to next one
    /* Add item to the end of the list. Items are NEWed, lists are getmemed */
    items[spot] = item; // we own it
    // set the id
    int iid;
    if (spot == 0)
      iid = 500; // for debugging
    else
      iid = items[spot - 1]->get_itemid() + 1;
    items[spot]->set_itemid(iid);
    used[spot] = (ZFLAG)TRUE;
    if (fillin == FALSE)
      itemscount++;
    return spot; // we return array position we stored in, not ID
  }

int zary::FindPos (int itemid)
  {
    int lp;
    for (lp = 0; lp < itemscount; lp++)
      if (used[lp] != FALSE)
        if (items[lp]->get_itemid() == itemid)
          return lp;
    return -1;
  }
  
void zary::Del (int id)
  {
    /* Find this item's id */
    int lp = FindPos (id);
    if (lp != -1)
      DelPos(lp);
  }

void zary::DelPos (int pos)
  {
    if (pos != -1)
      {
        used[pos] = FALSE;
        if (items[pos] == NULL)
          return;
        delete items[pos];
        items[pos] = NULL; // very important, not everybody uses the 'used' flag
      }
  }

