/*
    This file is part of O3.
    Copyright 2002, 2003 Stu Mark
    This program is distributed under the terms of the GNU 
    General Public License 

    O3 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    O3 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with O3; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef FPACK_H
#define FPACK_H

/* All response codes start from 2 and up. That way, we can tell between a 
   call failure (0/FALSE), a good return (1/TRUE) and a specific error (2....) */

/* We're not worried about platform endianness */

#define PROTOCOL_ID 0x0a0a0a0a  
enum fcmd
  {
    FP_CLOSECONN  =   1,
    FP_OPENFILE   =   2,
    FP_CLOSEFILE  =   3,

    FP_GETHEADER  =   4,
    FP_SETHEADER  =   5,

    FP_READREC    =   6,
    FP_WRITEREC   =   7,
    FP_DELETEREC  =   8,

    FP_ISEEK      =   9,
    FP_IUPDATE    =  10,
    FP_IINSERT    =  11,
    FP_IDELETE    =  12,

    FP_FIRSTREC   =  13,
    FP_LASTREC    =  14,
    FP_SEEKREC    =  15,
    FP_NEXTREC    =  16,
    FP_PREVREC    =  17,

    FP_BSEEK      =  18,
    FP_BINSERT    =  19,
    FP_BDELETE    =  20,
    
    FP_REINDEX    =  21,

    // 8/29/00 forgot these
    FP_IATOMICINSERT =  22,
    FP_BATOMICINSERT =  23,
    
    // I'm so cool 1/12/01
    FP_ISELECT       =  24,
    
    // I'm sooooooo stupid 1/2/03
    FP_IATOMICUPDATE = 25
  };

enum fresp
  {
    FR_FAIL            = 0,
    FR_OK              = 1,
    FR_NOTCONNETED     = 2,
    FR_COMMERROR       = 3,
    FR_OPENFAILED      = 4,
    FR_NOTIMPLEMENTED  = 5,
    FR_BADFILEID       = 6,
    FR_PROTOCOLERROR   = 7,
    FR_NOTFOUND        = 8,
    FR_DUPLICATE       = 9
  };

typedef struct tagFlatPacket
  {
    fcmd command;
    int protocolid;
    int fileid;
    long recno;
  } FlatPacket;

typedef struct tagFlatResponse
  {
    fresp rc;
    int protocolid;
    union tagresp
     { 
       long recno;
       int id;
     } data;
  } FlatResponse;


#endif


