/*
    This file is part of O3.
    Copyright 2002, 2003 Stu Mark
    This program is distributed under the terms of the GNU 
    General Public License 

    O3 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    O3 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with O3; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef ADMIN_H
#define ADMIN_H

void addconfigdefaults(ConfigCraft &ar);
int help(void);

class admin
  {
    public:
      admin(ConfigCraft &Ar, NoteCraft &ls, int Num, char *Opts[]);
      ~admin(void);
      int run(void);
      
    private:
      int adddomain(char *dm);
      int removedomain(char *dm);
      int listdomains(void);
      int relaydomain(char *dm, char *hostport);
      int unrelaydomain(char *dm);

      FlatConnection *getuser(char *username, char *domain, tuser *&u);
      int listusers(void);
      int adduser(char *username, char *domain, char *defstore);
      int showuserbyname(char *username, char *domain);
      int chpassword(char *username, char *domain, char *oldpassword, char *newpassword);
      int chtype(char *username, char *domain, char *type, char *altval);
      int chquota(char *username, char *domain, char *newquota);
      int chstatus(char *username, char *domain, char *password, char *newstatus);
      int chsmtpallow(char *username, char *domain, char *yn);
      int removeuser(char *username, char *domain);

      int getmessagedefstore(char *defstore);
      int setmessagedefstore(char *defstore, char *newmsgdefstore);

      int reindexdirectory(void);
      int reindex(char *defstore);

      ConfigCraft &ar;
      NoteCraft &ls;
      int num;
      char **opts;
      dbfinder *finder;
      tdirectory *dirholder;
    
  };
  



#endif








