/*
    This file is part of O3.
    Copyright 2002, 2003 Stu Mark
    This program is distributed under the terms of the GNU 
    General Public License 

    O3 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    O3 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with O3; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef SMTPSEND_H
#define SMTPSEND_H

/* I made this into a class for organizational sake. It used to be
   just a function.
   
   If you want to send mail via smtp, you make one of these guys,
   load it up with where who and what, and say GO. */
   
int gethostlistfordomain(Memory &rmsg, zlist &hostlist, char *domain);
int gethostlistfordomainsub(Memory &rmsg, zlist &hostlist, char *domain, int follows);
int sendmsg (socketio &sco, char *msgfile, NoteCraft &ls);
int prefixsort (const void *i1, const void *i2);

class smtpsend
  {
    public:
      smtpsend (ConfigCraft &Ar, NoteCraft &Ls, 
                char *toaddr, char *from, char *Msgfile);
      ~smtpsend(void);

      void addrecip(char *s);
      int go(Memory &rmsg, Memory &globalhost, int globalport);
      
    private:
      int badback (char *s1, char *s2, Memory &ret, socketio &sco, NoteCraft &ls, int retval);
      int gethostlistfordomain(Memory &rmsg, zlist &hosts, char *mxdomain);
      int gohost(Memory &rmsg, char *server, int port);
      
      ConfigCraft &ar;
      NoteCraft &ls;
      zlist reciplist;
      Memory msgfile;
      Memory mailfrom;
      Memory mxhost; // the domain we should deliver to
  };

#endif





