/*
    This file is part of O3.
    Copyright 2002, 2003 Stu Mark
    This program is distributed under the terms of the GNU 
    General Public License 

    O3 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    O3 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with O3; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef UTILS_H
#define UTILS_H

#define LOWER TRUE

void fieldtomemory(Memory &dest, char *src, int fieldlen);
void memorytofield(char *dest, char *src, int fieldlen, int lower = FALSE);
void namefromaddress(Memory &name, char *n);
void domainfromaddress(Memory &domain, char *n);
void setiplist (char *s, zlist &allowlist);
int isinlist(zlist &list, char *address);
void splithostportpath(char *pd, Memory &server, int &port, Memory &path);
int getpeeripstring(Memory &ip, Acceptor &ac);
int getfromorreplyto(Memory &from, Memory &envelopemailfrom, char *bf);
void md5hash (Memory &output, char *hashme);
void generaterfc822date(Memory &dt);
void generateboundary(Memory &boundary, char *starter);
void foldline(FILE *f, char *s2, int indent = TRUE);
void formatline(FILE *f, char *s2);
int recalculatequota(FlatConnection *dbc, UINT userid, ConfigCraft &ar, NoteCraft &ls);
void md5_calc(unsigned char *outbuf, unsigned char *hashme, int hashlen);
void fixsigpipe(NoteCraft &ls);
int checkfinder(ConfigCraft &ar, NoteCraft &ls, dbfinder *&finder, tdirectory *&dirholder);
inline int iswhitespace(char p);
int gettoken(char *&p, Memory &v);

#endif






